https://bugs.gentoo.org/829162
https://gitlab.haskell.org/ghc/ghc/-/issues/19655
https://gitlab.haskell.org/ghc/ghc/-/commit/ad2ef3a13f1eb000eab8e3d64592373b91a52806

From: Moritz Angermann <moritz.angermann@gmail.com>
Date: Wed, 17 Feb 2021 21:13:07 +0800
Subject: [PATCH] [configure] Fix _AC_PROG_CC_99

_AC_PROG_CC_99 isn't available anymore in recent autoconf versions.
This broke on aarch64-darwin.
--- a/aclocal.m4
+++ b/aclocal.m4
@@ -659,7 +659,7 @@ AC_DEFUN([FP_SET_CFLAGS_C99],
     CPPFLAGS="$$3"
     unset ac_cv_prog_cc_c99
     dnl perform detection
-    _AC_PROG_CC_C99
+    AC_PROG_CC_C99
     fp_cc_c99="$ac_cv_prog_cc_c99"
     case "x$ac_cv_prog_cc_c99" in
       x)   ;; # noop
GitLab